DCMTK Version 3.7.0 OFFIS DICOM Toolkit

Public Member Functions | Static Public Member Functions | Static Private Member Functions | Friends | List of all members
DcmTime Class Reference

a class representing the DICOM value representation 'Time' (TM) More...

Inheritance diagram for DcmTime:

## Public Member Functions
| DcmTime (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmTime (const DcmTime &old)
| copy constructor More...
virtual | ~DcmTime ()
| destructor
DcmTime & | operator= (const DcmTime &obj)
| assignment operator More...
virtual DcmObject * | clone () const
| clone method More...
virtual OFCondition | copyFrom (const DcmObject &rhs)
| Virtual object copying. More...
virtual DcmEVR | ident () const
| get element type identifier More...
virtual OFCondition | checkValue (const OFString &vm="1-n", const OFBool oldFormat=OFFalse)
| check whether stored value conforms to the VR and to the specified VM More...
virtual OFCondition | getOFString (OFString &stringValue, const unsigned long pos, OFBool normalize=OFTrue)
| get a copy of a particular string component More...
OFCondition | setCurrentTime (const OFBool seconds=OFTrue, const OFBool fraction=OFFalse)
| set the element value to the current system time. More...
OFCondition | setOFTime (const OFTime &timeValue)
| set the element value to the given time More...
OFCondition | getOFTime (OFTime &timeValue, const unsigned long pos=0, const OFBool supportOldFormat=OFTrue)
| get the current element value in OFTime format. More...
OFCondition | getISOFormattedTime (OFString &formattedTime, const unsigned long pos=0, const OFBool seconds=OFTrue, const OFBool fraction=OFFalse, const OFBool createMissingPart=OFFalse, const OFBool supportOldFormat=OFTrue)
| get the current element value in ISO time format. More...
virtual OFBool | matches (const OFString &key, const OFString &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching on a single pair of string values. More...
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching. More...
virtual OFBool | matches (const OFString &key, const OFString &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching on a single pair of string values. More...
Public Member Functions inherited from DcmByteString
| DcmByteString (const DcmTag &tag)
| constructor. More...
| DcmByteString (const DcmByteString &old)
| copy constructor More...
virtual | ~DcmByteString ()
| destructor
DcmByteString & | operator= (const DcmByteString &obj)
| assignment operator More...
virtual int | compare (const DcmElement &rhs) const
| comparison operator that compares the normalized value of this object with a given object of the same type. More...
virtual OFCondition | clear ()
| clear the currently stored value More...
virtual unsigned long | getVM ()
| get value multiplicity More...
virtual unsigned long | getNumberOfValues ()
| get number of values stored in this element. More...
Uint32 | getRealLength ()
| get length of the stored value. More...
virtual Uint32 | getLength (const E_TransferSyntax xfer=EXS_LittleEndianImplicit, const E_EncodingType enctype=EET_UndefinedLength)
| get DICOM length of the stored value. More...
virtual void | print (STD_NAMESPACE ostream &out, const size_t flags=0, const int level=0, const char *pixelFileName=NULL, size_t *pixelCounter=NULL)
| print element to a stream. More...
virtual OFCondition | write (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write data element to a stream More...
virtual OFCondition | writeSignatureFormat (DcmOutputStream &outStream, const E_TransferSyntax oxfer, const E_EncodingType enctype, DcmWriteCache *wcache)
| write data element to a stream as required for the creation of digital signatures More...
virtual OFCondition | getOFStringArray (OFString &stringVal, OFBool normalize=OFTrue)
| get entire element value as a character string. More...
virtual OFCondition | getString (char *&stringVal)
| get a pointer to the current string value. More...
virtual OFCondition | getString (char *&stringVal, Uint32 &stringLen)
| get a pointer to the current string value. More...
virtual OFCondition | putString (const char *stringVal)
| set element value from the given character string. More...
virtual OFCondition | putOFStringAtPos (const OFString &stringVal, const unsigned long pos=0)
| set element value at specific VM position in the given character string. More...
virtual OFCondition | putString (const char *stringVal, const Uint32 stringLen)
| set element value from the given character string. More...
virtual OFCondition | verify (const OFBool autocorrect=OFFalse)
| check the currently stored string value. More...
virtual OFBool | containsExtendedCharacters (const OFBool checkAllStrings=OFFalse)
| check if this element contains non-ASCII characters. More...
virtual OFBool | isAffectedBySpecificCharacterSet () const
| check if this element is affected by SpecificCharacterSet More...
virtual OFBool | isEmpty (const OFBool normalize=OFTrue)
| check if this object is empty More...
virtual OFCondition | writeJson (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write object in JSON format More...
virtual OFBool | matches (const DcmElement &candidate, const OFBool enableWildCardMatching=OFTrue) const
| perform attribute matching. More...
Public Member Functions inherited from DcmElement
| DcmElement (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmElement (const DcmElement &old)
| copy constructor More...
virtual | ~DcmElement ()
| destructor
DcmElement & | operator= (const DcmElement &obj)
| assignment operator More...
virtual Uint32 | calcElementLength (const E_TransferSyntax xfer, const E_EncodingType enctype)
| calculate the length of this DICOM element when encoded with the given transfer syntax and the given encoding type for sequences. More...
virtual OFBool | isLeaf () const
| check if this element is a leaf node in a dataset tree. More...
virtual OFBool | isElement () const
| check if this element can be safely casted to DcmElement More...
OFBool | valueLoaded () const
| check if value of this element is loaded into main memory More...
virtual void | transferInit ()
| initialize the transfer state of this object. More...
virtual OFBool | canWriteXfer (const E_TransferSyntax newXfer, const E_TransferSyntax oldXfer)
| check if this DICOM object can be encoded in the given transfer syntax. More...
virtual OFCondition | read (DcmInputStream &inStream, const E_TransferSyntax ixfer, const E_GrpLenEncoding glenc=EGL_noChange, const Uint32 maxReadLength=DCM_MaxReadLength)
| This function reads the data value of an attribute which is captured in the input stream and captures this information in this. More...
virtual OFCondition | writeXML (STD_NAMESPACE ostream &out, const size_t flags=0)
| write object in XML format More...
virtual OFCondition | loadAllDataIntoMemory ()
| this method loads all attribute values maintained by this object and all sub-objects (in case of a container such as DcmDataset) into memory. More...
virtual OFCondition | getUint8 (Uint8 &val, const unsigned long pos=0)
| retrieve a single value of type Uint8. More...
virtual OFCondition | getSint16 (Sint16 &val, const unsigned long pos=0)
| retrieve a single value of type Sint16. More...
virtual OFCondition | getUint16 (Uint16 &val, const unsigned long pos=0)
| retrieve a single value of type Uint16. More...
virtual OFCondition | getSint32 (Sint32 &val, const unsigned long pos=0)
| retrieve a single value of type Sint32. More...
virtual OFCondition | getUint32 (Uint32 &val, const unsigned long pos=0)
| retrieve a single value of type Uint32. More...
virtual OFCondition | getFloat32 (Float32 &val, const unsigned long pos=0)
| retrieve a single value of type Float32. More...
virtual OFCondition | getSint64 (Sint64 &val, const unsigned long pos=0)
| retrieve a single value of type Sint64. More...
virtual OFCondition | getUint64 (Uint64 &val, const unsigned long pos=0)
| retrieve a single value of type Uint64. More...
virtual OFCondition | getFloat64 (Float64 &val, const unsigned long pos=0)
| retrieve a single value of type Float64. More...
virtual OFCondition | getTagVal (DcmTagKey &val, const unsigned long pos=0)
| retrieve a single value of type DcmTagKey. More...
virtual OFCondition | getUint8Array (Uint8 *&val)
| get a pointer to the element value of the current element as type string. More...
virtual OFCondition | getSint16Array (Sint16 *&val)
| get a pointer to the element value of the current element as type Sint16. More...
virtual OFCondition | getUint16Array (Uint16 *&val)
| get a pointer to the element value of the current element as type Uint16. More...
virtual OFCondition | getSint32Array (Sint32 *&val)
| get a pointer to the element value of the current element as type Sint32. More...
virtual OFCondition | getUint32Array (Uint32 *&val)
| get a pointer to the element value of the current element as type Uint32. More...
virtual OFCondition | getFloat32Array (Float32 *&val)
| get a pointer to the element value of the current element as type Float32. More...
virtual OFCondition | getSint64Array (Sint64 *&val)
| get a pointer to the element value of the current element as type Sint64. More...
virtual OFCondition | getUint64Array (Uint64 *&val)
| get a pointer to the element value of the current element as type Uint64. More...
virtual OFCondition | getFloat64Array (Float64 *&val)
| get a pointer to the element value of the current element as type Float64. More...
OFCondition | detachValueField (OFBool copy=OFFalse)
| detach the value field from the DICOM element (i.e., this object). More...
virtual OFCondition | putOFStringArray (const OFString &val)
| replace the element value by a copy of the given string (which is possibly multi-valued). More...
virtual OFCondition | putSint16 (const Sint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint16 value. More...
virtual OFCondition | putUint16 (const Uint16 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint16 value. More...
virtual OFCondition | putSint32 (const Sint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint32 value. More...
virtual OFCondition | putUint32 (const Uint32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint32 value. More...
virtual OFCondition | putFloat32 (const Float32 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float32 value. More...
virtual OFCondition | putSint64 (const Sint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Sint64 value. More...
virtual OFCondition | putUint64 (const Uint64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Uint64 value. More...
virtual OFCondition | putFloat64 (const Float64 val, const unsigned long pos=0)
| insert into the element value a copy of the given Float64 value. More...
virtual OFCondition | putTagVal (const DcmTagKey &attrTag, const unsigned long pos=0)
| insert into the element value a copy of the given DcmTagKey value. More...
virtual OFCondition | putUint8Array (const Uint8 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint8 array (which is possibly multi-valued). More...
virtual OFCondition | putSint16Array (const Sint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint16 array (which is possibly multi-valued). More...
virtual OFCondition | putUint16Array (const Uint16 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint16 array (which is possibly multi-valued). More...
virtual OFCondition | putSint32Array (const Sint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint32 array (which is possibly multi-valued). More...
virtual OFCondition | putUint32Array (const Uint32 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint32 array (which is possibly multi-valued). More...
virtual OFCondition | putFloat32Array (const Float32 *vals, const unsigned long num)
| replace the element value by a copy of the given Float32 array (which is possibly multi-valued). More...
virtual OFCondition | putSint64Array (const Sint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Sint64 array (which is possibly multi-valued). More...
virtual OFCondition | putUint64Array (const Uint64 *vals, const unsigned long num)
| replace the element value by a copy of the given Uint64 array (which is possibly multi-valued). More...
virtual OFCondition | putFloat64Array (const Float64 *vals, const unsigned long num)
| replace the element value by a copy of the given Float64 array (which is possibly multi-valued). More...
virtual OFCondition | getPartialValue (void *targetBuffer, const Uint32 offset, Uint32 numBytes, DcmFileCache *cache=NULL, E_ByteOrder byteOrder=gLocalByteOrder)
| Copy numBytes bytes of data from the attribute value in byteOrder byte order to targetBuffer, starting at byte offset offset of the attribute value. More...
virtual OFCondition | createUint8Array (const Uint32 numBytes, Uint8 *&bytes)
| create an empty Uint8 array of given number of bytes and set it. More...
virtual OFCondition | createUint16Array (const Uint32 numWords, Uint16 *&words)
| create an empty Uint16 array of given number of words and set it. More...
virtual OFCondition | createValueFromTempFile (DcmInputStreamFactory *factory, const Uint32 length, const E_ByteOrder byteOrder)
| replace the attribute value with the content of the given temporary file. More...
virtual void | compact ()
| remove the attribute value from memory if the attribute value can be loaded from file when needed again. More...
virtual OFCondition | getUncompressedFrameSize (DcmItem *dataset, Uint32 &frameSize, OFBool pixelDataIsUncompressed) const
| compute uncompressed frame size of a single frame of this image. More...
virtual OFCondition | getUncompressedFrame (DcmItem *dataset, Uint32 frameNo, Uint32 &startFragment, void *buffer, Uint32 bufSize, OFString &decompressedColorModel, DcmFileCache *cache=NULL)
| access single frame without decompressing or loading a complete multi-frame object. More...
virtual OFCondition | getDecompressedColorModel (DcmItem *dataset, OFString &decompressedColorModel)
| determine color model of the decompressed image More...
virtual OFBool | isUniversalMatch (const OFBool normalize=OFTrue, const OFBool enableWildCardMatching=OFTrue)
| Determine if this element is universal matching. More...
virtual OFBool | combinationMatches (const DcmElement &keySecond, const DcmElement &candidateFirst, const DcmElement &candidateSecond) const
| perform combined attribute matching. More...
const DcmInputStreamFactory * | getInputStream () const
| returns a pointer to the input stream, if available, NULL otherwise. More...
virtual Uint16 | decodedBitsAllocated (Uint16 bitsAllocated, Uint16 bitsStored) const
| determines the effective value of BitsAllocated that a dataset will have after decompression of an image with the given values for bitsAllocated and bitsStored. More...
Public Member Functions inherited from DcmObject
| DcmObject (const DcmTag &tag, const Uint32 len=0)
| constructor. More...
| DcmObject (const DcmObject &obj)
| copy constructor More...
virtual | ~DcmObject ()
| destructor
DcmObject & | operator= (const DcmObject &obj)
| copy assignment operator More...
DcmEVR | getVR () const
| return the value representation assigned to this object. More...
OFBool | isaString () const
| check if this element is a string type, based on the VR. More...
virtual OFBool | isNested () const
| check if this element is nested in a sequence of items, i.e. not a top-level or stand-alone element More...
E_TransferState | transferState () const
| return the current transfer (read/write) state of this object. More...
virtual void | transferEnd (void)
| finalize the transfer state of this object. More...
DcmItem * | getRootItem ()
| get root dataset/item (top-level) that contains this object. More...
virtual DcmItem * | getParentItem ()
| get parent item of this object. More...
DcmObject * | getParent ()
| get parent of this object. More...
const DcmObject * | getParent () const
| get parent of this object. More...
void | setParent (DcmObject *parent)
| set parent of this object. More...
Uint16 | getGTag () const
| return the group number of the attribute tag for this object More...
Uint16 | getETag () const
| return the element number of the attribute tag for this object More...
const DcmTag & | getTag () const
| return const reference to the attribute tag for this object More...
void | setGTag (Uint16 gtag)
| assign group tag (but not element tag) of the attribute tag for this object. More...
virtual OFCondition | setVR (DcmEVR vr)
| assign a new Value Representation (VR) to this object. More...
virtual OFBool | isSignable () const
| returns true if the current object may be included in a digital signature More...
virtual OFBool | containsUnknownVR () const
| returns true if the object contains an element with Unknown VR at any nesting level More...
virtual OFCondition | convertCharacterSet (DcmSpecificCharacterSet &converter)
| convert this object from the currently selected source character set to the currently selected destination character set (if affected by SpecificCharacterSet) More...
virtual DcmObject * | nextInContainer (const DcmObject *obj)
| this method is only used in container classes derived from this class, that is, DcmItem and DcmSequenceOfItems. More...
virtual OFCondition | nextObject (DcmStack &stack, const OFBool intoSub)
| this method enables a stack based, depth-first traversal of a complete hierarchical DICOM dataset (that is, classes derived from DcmItem or DcmSequenceOfItems). More...
virtual OFCondition | search (const DcmTagKey &xtag, DcmStack &resultStack, E_SearchMode mode=ESM_fromHere, OFBool searchIntoSub=OFTrue)
| a complex, stack-based, hierarchical search method. More...
Uint32 | getLengthField () const
| return the current value of the Length field (which is different from the functionality of the public getLength() method). More...

## Static Public Member Functions
static OFCondition | getCurrentTime (OFString &dicomTime, const OFBool seconds=OFTrue, const OFBool fraction=OFFalse)
| get the current system time. More...
static OFCondition | getDicomTimeFromOFTime (const OFTime &timeValue, OFString &dicomTime, const OFBool seconds=OFTrue, const OFBool fraction=OFFalse)
| get the specified OFTime value in DICOM format. More...
static OFCondition | getOFTimeFromString (const OFString &dicomTime, OFTime &timeValue)
| get the specified DICOM time value in OFTime format. More...
static OFCondition | getOFTimeFromString (const OFString &dicomTime, OFTime &timeValue, const OFBool supportOldFormat)
| get the specified DICOM time value in OFTime format. More...
static OFCondition | getOFTimeFromString (const OFString &dicomTime, OFTime &timeValue, const OFBool supportOldFormat, const double timeZone)
| get the specified DICOM time value in OFTime format. More...
static OFCondition | getOFTimeFromString (const char *dicomTime, const size_t dicomTimeSize, OFTime &timeValue)
| get the specified DICOM time value in OFTime format. More...
static OFCondition | getOFTimeFromString (const char *dicomTime, const size_t dicomTimeSize, OFTime &timeValue, const OFBool supportOldFormat)
| get the specified DICOM time value in OFTime format. More...
static OFCondition | getOFTimeFromString (const char *dicomTime, const size_t dicomTimeSize, OFTime &timeValue, const OFBool supportOldFormat, const double timeZone)
| get the specified DICOM time value in OFTime format. More...
static OFCondition | getISOFormattedTimeFromString (const OFString &dicomTime, OFString &formattedTime, const OFBool seconds=OFTrue, const OFBool fraction=OFFalse, const OFBool createMissingPart=OFFalse, const OFBool supportOldFormat=OFTrue)
| get the specified DICOM time value in ISO format. More...
static OFCondition | getTimeZoneFromString (const OFString &dicomTimeZone, double &timeZone)
| get the specified DICOM time zone in number of hours format DICOM standard states that if the "Timezone Offset From UTC" attribute (0008,0201) is present it applies to all TM attributes in the object. More...
static OFCondition | getTimeZoneFromString (const char *dicomTimeZone, const size_t dicomTimeZoneSize, double &timeZone)
| get the specified DICOM time zone in number of hours format DICOM standard states that if the "Timezone Offset From UTC" attribute (0008,0201) is present it applies to all TM attributes in the object. More...
static OFBool | check (const char *dicomTime, const size_t dicomTimeSize)
| check whether given string conforms to a single value of VR "TM" (Time). More...
static OFBool | check (const char *dicomTime, const size_t dicomTimeSize, const OFBool supportOldFormat)
| check whether given string conforms to a single value of VR "TM" (Time). More...
static OFCondition | checkStringValue (const OFString &value, const OFString &vm="1-n", const OFBool oldFormat=OFFalse)
| check whether given string value conforms to the VR "TM" (Time) and to the specified VM. More...
Static Public Member Functions inherited from DcmElement
static int | scanValue (const OFString &value, const OFString &vr, const size_t pos=0, const size_t num=OFString_npos)
| scan string value for conformance with given value representation (VR) More...
static int | scanValue (const OFString &vr, const char *const value, const size_t size)
| scan string value for conformance with given value representation (VR) More...
static unsigned long | determineVM (const char *str, const size_t len)
| determine the number of values stored in a string, i.e. the value multiplicity (VM) More...
static size_t | getValueFromString (const char *str, const size_t pos, const size_t len, OFString &val)
| get the first value stored in the given string. More...
static OFCondition | checkVM (const unsigned long vmNum, const OFString &vmStr)
| check for correct value multiplicity (VM) More...

## Static Private Member Functions
static OFBool | parseFragment (const char *string, const size_t size, double &result)
| parse the fragment part of a DICOM time string. More...

## Friends
class | DcmDate
| give DcmDate access to our private parts, for combined date time range matching.

## Additional Inherited Members
Protected Types inherited from DcmByteString
enum | E_StringMode { DCM_MachineString , DCM_DicomString , DCM_UnknownString }
| internal type used to specify the current string representation More...
Protected Member Functions inherited from DcmByteString
| DcmByteString (const DcmTag &tag, const Uint32 len)
| constructor. More...
virtual Uint8 * | newValueField ()
| create a new value field (string buffer) of the previously defined size (member variable 'Length'). More...
virtual void | postLoadValue ()
| method is called after the element value has been loaded. More...
E_StringMode | getStringMode () const
| get current representation of the string value More...
virtual OFCondition | makeMachineByteString (const Uint32 length=0)
| convert currently stored string value to internal representation. More...
OFCondition | makeDicomByteString ()
| convert currently stored string value to DICOM representation. More...
OFCondition | getStringValue (OFString &stringVal)
| get a copy of the current string value. More...
Uint32 | getMaxLength () const
| get the maximum number of characters for each string component More...
char | getPaddingChar () const
| get the end-of-string padding character More...
void | setPaddingChar (char c)
| set the end-of-string padding character More...
void | setMaxLength (Uint32 val)
| set the maximum number of characters for each string component More...
void | setNonSignificantChars (const OFString &characters)
| set non-significant characters used to determine whether the value is empty More...
Protected Member Functions inherited from DcmElement
void * | getValue (const E_ByteOrder newByteOrder=gLocalByteOrder)
| This function returns this element's value. More...
OFCondition | changeValue (const void *value, const Uint32 position, const Uint32 num)
| insert into the element value a copy of the given raw value. More...
OFCondition | putValue (const void *value, const Uint32 length)
| replace the element value by a copy of the given raw data block More...
OFCondition | createEmptyValue (const Uint32 length)
| create a new, empty value field of given size. More...
OFCondition | loadValue (DcmInputStream *inStream=NULL)
| This function reads the data value of an attribute and stores the information which was read in this. More...
void | swapValueField (size_t valueWidth)
| swaps the content of the value field (if loaded) from big-endian to little-endian or back More...
virtual void | writeXMLStartTag (STD_NAMESPACE ostream &out, const size_t flags, const char *attrText=NULL)
| write element start tag in XML format More...
virtual void | writeXMLEndTag (STD_NAMESPACE ostream &out, const size_t flags)
| write element end tag in XML format More...
virtual void | writeJsonOpener (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element start tag in JSON format More...
virtual void | writeJsonCloser (STD_NAMESPACE ostream &out, DcmJsonFormat &format)
| write element end tag in JSON format More...
E_ByteOrder | getByteOrder () const
| return the current byte order of the value field More...
void | setByteOrder (E_ByteOrder val)
| set the current byte order of the value field More...
Protected Member Functions inherited from DcmObject
void | printNestingLevel (STD_NAMESPACE ostream &out, const size_t flags, const int level)
| print line indentation, e.g. a couple of spaces for each nesting level. More...
void | printInfoLineStart (STD_NAMESPACE ostream &out, const size_t flags, const int level, DcmTag *tag=NULL)
| print beginning of the info line. More...
void | printInfoLineEnd (STD_NAMESPACE ostream &out, const size_t flags, const unsigned long printedLength=0xffffffff, DcmTag *tag=NULL)
| print end of the info line. More...
virtual void | printInfoLine (STD_NAMESPACE ostream &out, const size_t flags, const int level=0, const char *info=NULL, DcmTag *tag=NULL, const OFBool isInfo=OFTrue)
| print given text with element information. More...
virtual OFCondition | writeTagAndLength (DcmOutputStream &outStream, const E_TransferSyntax oxfer, Uint32 &writtenBytes) const
| write tag, VR and length field to the given output stream More...
virtual Uint32 | getTagAndLengthSize (const E_TransferSyntax oxfer) const
| return the number of bytes needed to serialize the tag, VR and length information of the current object using the given transfer syntax. More...
const char * | getTagName ()
| return the DICOM attribute tag name for this object. More...
void | setTagVR (DcmEVR vr)
| set the VR for this attribute More...
E_TransferState | getTransferState () const
| return the current transfer state of this object during serialization/deserialization More...
void | setTransferState (E_TransferState newState)
| set the current transfer state of this object during serialization/deserialization More...
Uint32 | getTransferredBytes () const
| return the number of transferred bytes for this object during serialization/deserialization More...
void | setTransferredBytes (Uint32 val)
| set the number of transferred bytes for this object during serialization/deserialization More...
void | incTransferredBytes (Uint32 val)
| add to the number of transferred bytes for this object during serialization/deserialization More...
void | setLengthField (Uint32 val)
| set the current value of the Length field More...
Static Protected Member Functions inherited from DcmByteString
static OFBool | containsExtendedCharacters (const char *stringVal, const size_t stringLen)
| check if a given character string contains non-ASCII characters. More...
static OFCondition | checkStringValue (const OFString &value, const OFString &vm, const OFString &vr, const int vrID, const size_t maxLen=0, const OFString &charset="")
| check whether given string value conforms to a certain VR and VM. More...
Static Protected Member Functions inherited from DcmObject
static OFCondition | writeTag (DcmOutputStream &outStream, const DcmTag &tag, const E_TransferSyntax oxfer)
| static helper function that writes a given attribute tag to a binary output stream using the byte order indicated by the transfer syntax. More...
Protected Attributes inherited from DcmObject
OFCondition | errorFlag
| error flag for this object.

## Detailed Description

a class representing the DICOM value representation 'Time' (TM)

## Constructor & Destructor Documentation

## ◆ DcmTime() [1/2]

DcmTime::DcmTime | ( | const DcmTag & | tag,
|  | const Uint32 | len = `0`
| ) |  |

constructor.

Create new element from given tag and length.

Parameters

  tag | DICOM tag for the new element
  len | value length for the new element

## ◆ DcmTime() [2/2]

DcmTime::DcmTime | ( | const DcmTime & | old | ) |

copy constructor

Parameters

  old | element to be copied

## Member Function Documentation

## ◆ check() [1/2]

static OFBool DcmTime::check | ( | const char * | dicomTime,
|  | const size_t | dicomTimeSize
| ) |  |
| static

check whether given string conforms to a single value of VR "TM" (Time).

The old ACR/NEMA time format is considered invalid.

Parameters

  dicomTime | string value to be checked
  dicomTimeSize | the size (in bytes) of the string 'dicomTime' refers to

Returns
  OFTrue if the given string conforms to the Time format, OFFalse otherwise

## ◆ check() [2/2]

static OFBool DcmTime::check | ( | const char * | dicomTime,
|  | const size_t | dicomTimeSize,
|  | const OFBool | supportOldFormat
| ) |  |
| static

check whether given string conforms to a single value of VR "TM" (Time).

Parameters

  dicomTime | string value to be checked
  dicomTimeSize | the size (in bytes) of the string 'dicomTime' refers to
  supportOldFormat | whether to accept the old ACR/NEMA time format. Set to OFTrue for enabling support for (HH:MM:SS in addition to HHMMSS...). Defaults to OFFalse, disabling it by default.

Returns
  OFTrue if the given string conforms to the Time format, OFFalse otherwise

## ◆ checkStringValue()

static OFCondition DcmTime::checkStringValue | ( | const OFString & | value,
|  | const OFString & | vm = `"1-n"`,
|  | const OFBool | oldFormat = `OFFalse`
| ) |  |
| static

check whether given string value conforms to the VR "TM" (Time) and to the specified VM.

Parameters

  value | string value to be checked (possibly multi-valued)
  vm | value multiplicity (according to the data dictionary) to be checked for. (See DcmElement::checkVM() for a list of valid values.)
  oldFormat | support old ACR/NEMA time format if OFTrue (i.e. with ":" and "." delimiters)

Returns
  status of the check, EC_Normal if value is correct, an error code otherwise

## ◆ checkValue()

virtual OFCondition DcmTime::checkValue | ( | const OFString & | vm = `"1-n"`,
|  | const OFBool | oldFormat = `OFFalse`
| ) |  |
| virtual

check whether stored value conforms to the VR and to the specified VM

Parameters

  vm | value multiplicity (according to the data dictionary) to be checked for. (See DcmElement::checkVM() for a list of valid values.)
  oldFormat | support old ACR/NEMA format if OFTrue (':' as a separator)

Returns
  status of the check, EC_Normal if value is correct, an error code otherwise

Reimplemented from DcmElement.

## ◆ clone()

virtual DcmObject* DcmTime::clone | ( |  | ) | const
| inline virtual

clone method

Returns
  deep copy of this object

Reimplemented from DcmByteString.

## ◆ copyFrom()

virtual OFCondition DcmTime::copyFrom | ( | const DcmObject & | rhs | ) |
| virtual

Virtual object copying.

This method can be used for DcmObject and derived classes to get a deep copy of an object. Internally the assignment operator is called if the given DcmObject parameter is of the same type as "this" object instance. If not, an error is returned. This function permits copying an object by value in a virtual way which therefore is different to just calling the assignment operator of DcmElement which could result in slicing the object.

Parameters

  rhs | - [in] The instance to copy from. Has to be of the same class type as "this" object

Returns
  EC_Normal if copying was successful, error otherwise

Reimplemented from DcmByteString.

## ◆ getCurrentTime()

static OFCondition DcmTime::getCurrentTime | ( | OFString & | dicomTime,
|  | const OFBool | seconds = `OFTrue`,
|  | const OFBool | fraction = `OFFalse`
| ) |  |
| static

get the current system time.

The DICOM TM format supported by this function is "HHMM[SS[.FFFFFF]]" where the brackets enclose optional parts. If the current system time or parts of it are unavailable the corresponding values are set to "0" and an error code is returned.

Parameters

  dicomTime | reference to string variable where the result is stored
  seconds | add optional seconds ("SS") if OFTrue
  fraction | add optional fractional part of a second (".FFFFFF") if OFTrue (requires parameter 'seconds' to be also OFTrue)

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getDicomTimeFromOFTime()

static OFCondition DcmTime::getDicomTimeFromOFTime | ( | const OFTime & | timeValue,
|  | OFString & | dicomTime,
|  | const OFBool | seconds = `OFTrue`,
|  | const OFBool | fraction = `OFFalse`
| ) |  |
| static

get the specified OFTime value in DICOM format.

The DICOM TM format supported by this function is "HHMM[SS[.FFFFFF]]" where the brackets enclose optional parts. If the current system time or parts of it are unavailable the corresponding values are set to "0" and an error code is returned.

Parameters

  timeValue | time to be converted to DICOM format
  dicomTime | reference to string variable where the result is stored
  seconds | add optional seconds ("SS") if OFTrue
  fraction | add optional fractional part of a second (".FFFFFF") if OFTrue (requires parameter 'seconds' to be also OFTrue)

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getISOFormattedTime()

OFCondition DcmTime::getISOFormattedTime | ( | OFString & | formattedTime,
|  | const unsigned long | pos = `0`,
|  | const OFBool | seconds = `OFTrue`,
|  | const OFBool | fraction = `OFFalse`,
|  | const OFBool | createMissingPart = `OFFalse`,
|  | const OFBool | supportOldFormat = `OFTrue`
| ) |  |

get the current element value in ISO time format.

The ISO time format supported by this function is "HH:MM[:SS[.FFFFFF]]" where the brackets enclose optional parts. Please note that the element value is expected to be in valid DICOM TM format ("[HH[MM[SS[.FFFFFF]]]]", "[HH[:MM[:SS[.FFFFFF]]]]" is also supported for reasons of backward compatibility). If this function fails or the current element value is empty, the result variable 'formattedTime' is cleared automatically. Please note that if the "Timezone Offset From UTC" attribute (0008,0201) is present, it applies to all TM attributes in the object. However, the time zone is not taken into account for the creation of the ISO formatted time. See also "getTimeZoneFromString()" below.

Parameters

  formattedTime | reference to string variable where the result is stored
  pos | index of the element component in case of value multiplicity (0..vm-1)
  seconds | add optional seconds (":SS") if OFTrue
  fraction | add optional fractional part of a second (".FFFFFF") if OFTrue (requires parameter 'seconds' to be also OFTrue)
  createMissingPart | if OFTrue create optional parts (seconds and/or fractional part of a seconds) if absent in the element value
  supportOldFormat | if OFTrue support old (prior V3.0) time format (see above)

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getISOFormattedTimeFromString()

static OFCondition DcmTime::getISOFormattedTimeFromString | ( | const OFString & | dicomTime,
|  | OFString & | formattedTime,
|  | const OFBool | seconds = `OFTrue`,
|  | const OFBool | fraction = `OFFalse`,
|  | const OFBool | createMissingPart = `OFFalse`,
|  | const OFBool | supportOldFormat = `OFTrue`
| ) |  |
| static

get the specified DICOM time value in ISO format.

The ISO time format supported by this function is "HH:MM[:SS[.FFFFFF]]" where the brackets enclose optional parts. Please note that the specified value is expected to be in valid DICOM TM format ("[HH[MM[SS[.FFFFFF]]]]", "[HH[:MM[:SS[.FFFFFF]]]]" is also supported for reasons of backward compatibility). If this function fails or the specified DICOM time value is empty, the result variable 'formattedTime' is cleared automatically.

Parameters

  dicomTime | string value in DICOM TM format to be converted to ISO format
  formattedTime | reference to string variable where the result is stored
  seconds | add optional seconds (":SS") if OFTrue
  fraction | add optional fractional part of a second (".FFFFFF") if OFTrue (requires parameter 'seconds' to be also OFTrue)
  createMissingPart | if OFTrue create optional parts (seconds and/or fractional part of a seconds) if absent in the DICOM TM value
  supportOldFormat | set to OFFalse to disable support for old (prior V3.0) time format (see above).

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getOFString()

virtual OFCondition DcmTime::getOFString | ( | OFString & | stringValue,
|  | const unsigned long | pos,
|  | OFBool | normalize = `OFTrue`
| ) |  |
| virtual

get a copy of a particular string component

Parameters

  stringValue | variable in which the result value is stored
  pos | index of the value in case of multi-valued elements (0..vm-1)
  normalize | delete trailing spaces if OFTrue

Returns
  status, EC_Normal if successful, an error code otherwise

Reimplemented from DcmByteString.

## ◆ getOFTime()

OFCondition DcmTime::getOFTime | ( | OFTime & | timeValue,
|  | const unsigned long | pos = `0`,
|  | const OFBool | supportOldFormat = `OFTrue`
| ) |  |

get the current element value in OFTime format.

Please note that the element value is expected to be in valid DICOM TM format ("[HH[MM[SS[.FFFFFF]]]]", "[HH[:MM[:SS[.FFFFFF]]]]" is also supported for reasons of backward compatibility). Since there is no time zone for the DICOM TM format local time is assumed (the time zone of 'timeValue' is set automatically). If this function fails the result variable 'timeValue' is cleared automatically.

Parameters

  timeValue | reference to OFTime variable where the result is stored
  pos | index of the element component in case of value multiplicity (0..vm-1)
  supportOldFormat | if OFTrue support old (prior V3.0) time format (see above)

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getOFTimeFromString() [1/6]

static OFCondition DcmTime::getOFTimeFromString | ( | const char * | dicomTime,
|  | const size_t | dicomTimeSize,
|  | OFTime & | timeValue
| ) |  |
| static

get the specified DICOM time value in OFTime format.

Please note that the element value is expected to be in valid DICOM TM format ("HH[MM[SS[.FFFFFF]]]", "HH[:MM[:SS[.FFFFFF]]]" is also supported for reasons of backward compatibility). Since there is no time zone for the DICOM TM format local time is assumed (the time zone of 'timeValue' is set automatically). If this function fails the result variable 'timeValue' is cleared automatically.

Parameters

  dicomTime | string value in DICOM TM format to be converted to OFTime format. An empty string is not regarded as valid input, since the time would be unknown.
  dicomTimeSize | the size (in bytes) of the string 'dicomTime' refers to
  timeValue | reference to OFTime variable where the result is stored

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getOFTimeFromString() [2/6]

static OFCondition DcmTime::getOFTimeFromString | ( | const char * | dicomTime,
|  | const size_t | dicomTimeSize,
|  | OFTime & | timeValue,
|  | const OFBool | supportOldFormat
| ) |  |
| static

get the specified DICOM time value in OFTime format.

Please note that the element value is expected to be in valid DICOM TM format ("HH[MM[SS[.FFFFFF]]]", "HH[:MM[:SS[.FFFFFF]]]" is also supported for reasons of backward compatibility). Since there is no time zone for the DICOM TM format local time is assumed (the time zone of 'timeValue' is set automatically). If this function fails the result variable 'timeValue' is cleared automatically.

Parameters

  dicomTime | string value in DICOM TM format to be converted to OFTime format. An empty string is not regarded as valid input, since the time would be unknown.
  dicomTimeSize | the size (in bytes) of the string 'dicomTime' refers to
  timeValue | reference to OFTime variable where the result is stored
  supportOldFormat | set to OFFalse to disable support for old (prior V3.0) time format (see above).

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getOFTimeFromString() [3/6]

static OFCondition DcmTime::getOFTimeFromString | ( | const char * | dicomTime,
|  | const size_t | dicomTimeSize,
|  | OFTime & | timeValue,
|  | const OFBool | supportOldFormat,
|  | const double | timeZone
| ) |  |
| static

get the specified DICOM time value in OFTime format.

Please note that the element value is expected to be in valid DICOM TM format ("HH[MM[SS[.FFFFFF]]]", "HH[:MM[:SS[.FFFFFF]]]" is also supported for reasons of backward compatibility). This overload of the function will set the time zone of 'timeValue' to the value given via the 'timeZone' parameter. If this function fails the result variable 'timeValue' is cleared automatically.

Parameters

  dicomTime | string value in DICOM TM format to be converted to OFTime format. An empty string is not regarded as valid input, since the time would be unknown.
  dicomTimeSize | the size (in bytes) of the string 'dicomTime' refers to
  timeValue | reference to OFTime variable where the result is stored
  supportOldFormat | set to OFFalse to disable support for old (prior V3.0) time format (see above).
  timeZone | the time zone to set for 'timeValue'.

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getOFTimeFromString() [4/6]

static OFCondition DcmTime::getOFTimeFromString | ( | const OFString & | dicomTime,
|  | OFTime & | timeValue
| ) |  |
| static

get the specified DICOM time value in OFTime format.

Please note that the element value is expected to be in valid DICOM TM format ("HH[MM[SS[.FFFFFF]]]", "HH[:MM[:SS[.FFFFFF]]]" is also supported for reasons of backward compatibility). Since there is no time zone for the DICOM TM format local time is assumed (the time zone of 'timeValue' is set automatically). If this function fails the result variable 'timeValue' is cleared automatically.

Parameters

  dicomTime | string value in DICOM TM format to be converted to OFTime format. An empty string is not regarded as valid input, since the time would be unknown.
  timeValue | reference to OFTime variable where the result is stored

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getOFTimeFromString() [5/6]

static OFCondition DcmTime::getOFTimeFromString | ( | const OFString & | dicomTime,
|  | OFTime & | timeValue,
|  | const OFBool | supportOldFormat
| ) |  |
| static

get the specified DICOM time value in OFTime format.

Please note that the element value is expected to be in valid DICOM TM format ("HH[MM[SS[.FFFFFF]]]", "HH[:MM[:SS[.FFFFFF]]]" is also supported for reasons of backward compatibility). Since there is no time zone for the DICOM TM format local time is assumed (the time zone of 'timeValue' is set automatically). If this function fails the result variable 'timeValue' is cleared automatically.

Parameters

  dicomTime | string value in DICOM TM format to be converted to OFTime format. An empty string is not regarded as valid input, since the time would be unknown.
  timeValue | reference to OFTime variable where the result is stored
  supportOldFormat | set to OFFalse to disable support for old (prior V3.0) time format (see above).

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getOFTimeFromString() [6/6]

static OFCondition DcmTime::getOFTimeFromString | ( | const OFString & | dicomTime,
|  | OFTime & | timeValue,
|  | const OFBool | supportOldFormat,
|  | const double | timeZone
| ) |  |
| static

get the specified DICOM time value in OFTime format.

Please note that the element value is expected to be in valid DICOM TM format ("HH[MM[SS[.FFFFFF]]]", "HH[:MM[:SS[.FFFFFF]]]" is also supported for reasons of backward compatibility). This overload of the function will set the time zone of 'timeValue' to the value given via the 'timeZone' parameter. If this function fails the result variable 'timeValue' is cleared automatically.

Parameters

  dicomTime | string value in DICOM TM format to be converted to OFTime format. An empty string is not regarded as valid input, since the time would be unknown.
  timeValue | reference to OFTime variable where the result is stored
  supportOldFormat | set to OFFalse to disable support for old (prior V3.0) time format (see above).
  timeZone | the time zone to set for 'timeValue'.

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getTimeZoneFromString() [1/2]

static OFCondition DcmTime::getTimeZoneFromString | ( | const char * | dicomTimeZone,
|  | const size_t | dicomTimeZoneSize,
|  | double & | timeZone
| ) |  |
| static

get the specified DICOM time zone in number of hours format DICOM standard states that if the "Timezone Offset From UTC" attribute (0008,0201) is present it applies to all TM attributes in the object.

This functions allows to convert the DICOM format ("&ZZZZ" where "&" is "+" or "-" and "ZZZZ" hours and minutes) to a floating point value, e.g. "+1.0" means plus one hour and "-2.5" minus two and a half hour, i.e. 2 hours and 30 minutes. The resulting 'timeZone' value can be used in conjunction with a OFTime object to convert the time to different time zones (e.g. to local time or UTC).

Parameters

  dicomTimeZone | string value in DICOM format ("&ZZZZ") to be converted
  timeZone | reference to floating point variable where the resulting UTC offset is stored
  dicomTimeZoneSize | the size (in bytes) of the string 'dicomTimeZone' refers to

Returns
  EC_Normal upon success, an error code otherwise

## ◆ getTimeZoneFromString() [2/2]

static OFCondition DcmTime::getTimeZoneFromString | ( | const OFString & | dicomTimeZone,
|  | double & | timeZone
| ) |  |
| static

get the specified DICOM time zone in number of hours format DICOM standard states that if the "Timezone Offset From UTC" attribute (0008,0201) is present it applies to all TM attributes in the object.

This functions allows to convert the DICOM format ("&ZZZZ" where "&" is "+" or "-" and "ZZZZ" hours and minutes) to a floating point value, e.g. "+1.0" means plus one hour and "-2.5" minus two and a half hour, i.e. 2 hours and 30 minutes. The resulting 'timeZone' value can be used in conjunction with a OFTime object to convert the time to different time zones (e.g. to local time or UTC).

Parameters

  dicomTimeZone | string value in DICOM format ("&ZZZZ") to be converted
  timeZone | reference to floating point variable where the resulting UTC offset is stored

Returns
  EC_Normal upon success, an error code otherwise

## ◆ ident()

virtual DcmEVR DcmTime::ident | ( |  | ) | const
| virtual

get element type identifier

Returns
  type identifier of this class (EVR_TM)

Reimplemented from DcmByteString.

## ◆ matches() [1/3]

virtual OFBool DcmByteString::matches

perform attribute matching.

Perform attribute matching on a candidate element using this element as the matching key.

Note
  The given candidate element must refer to the same attribute kind, i.e. have the same tag and VR. The method will return OFFalse if it doesn't.

Parameters

  candidate | the candidate element to compare this element with.
  enableWildCardMatching | enable or disable wild card matching. Defaults to OFTrue, which means wild card matching is performed if the element's VR supports it. Set to OFFalse to force single value matching instead.

Returns
  OFTrue if the candidate matches this element, OFFalse otherwise.

## ◆ matches() [2/3]

virtual OFBool DcmByteString::matches

perform attribute matching on a single pair of string values.

Compare two single string values using the attribute matching function appropriate for this element's VR (Universal Matching, Single Value Matching, Wild Card Matching or Range Matching).

Note
  This method is called by the other overload of matches() for each combination of values in the key and candidate element (implementing multi value matching for elements with VM>1).

Parameters

  key | the key value to match against the candidate.
  candidate | the candidate value to match the key against.
  enableWildCardMatching | enable or disable wild card matching. Defaults to OFTrue, which means wild card matching is performed if the element's VR supports it. Set to OFFalse to force single value matching instead.

Returns
  OFTrue if the candidate string matches the key string, OFFalse otherwise.

## ◆ matches() [3/3]

virtual OFBool DcmTime::matches | ( | const OFString & | key,
|  | const OFString & | candidate,
|  | const OFBool | enableWildCardMatching = `OFTrue`
| ) |  | const
| virtual

perform attribute matching on a single pair of string values.

Compare two single string values using the attribute matching function appropriate for this element's VR (Universal Matching, Single Value Matching, Wild Card Matching or Range Matching).

Note
  This method is called by the other overload of matches() for each combination of values in the key and candidate element (implementing multi value matching for elements with VM>1).

Parameters

  key | the key value to match against the candidate.
  candidate | the candidate value to match the key against.
  enableWildCardMatching | enable or disable wild card matching. Defaults to OFTrue, which means wild card matching is performed if the element's VR supports it. Set to OFFalse to force single value matching instead.

Returns
  OFTrue if the candidate string matches the key string, OFFalse otherwise.

Reimplemented from DcmByteString.

## ◆ operator=()

DcmTime& DcmTime::operator= | ( | const DcmTime & | obj | ) |

assignment operator

Parameters

  obj | element to be assigned/copied

Returns
  reference to this object

## ◆ parseFragment()

static OFBool DcmTime::parseFragment | ( | const char * | string,
|  | const size_t | size,
|  | double & | result
| ) |  |
| static private

parse the fragment part of a DICOM time string.

Parameters

  string | a pointer to the beginning of the fragment portion of a DICOM time string.
  size | the size (in bytes) of the given string value.
  result | a reference to a double value that will receive the result.

Returns
  OFTrue if the fragment was parsed successfully, OFFalse otherwise.

## ◆ setCurrentTime()

OFCondition DcmTime::setCurrentTime | ( | const OFBool | seconds = `OFTrue`,
|  | const OFBool | fraction = `OFFalse`
| ) |  |

set the element value to the current system time.

The DICOM TM format supported by this function is "HHMM[SS[.FFFFFF]]" where the brackets enclose optional parts. If the current system time or parts of it are unavailable the corresponding values are set to "0" and an error code is returned.

Parameters

  seconds | add optional seconds ("SS") if OFTrue
  fraction | add optional fractional part of a second (".FFFFFF") if OFTrue (requires parameter 'seconds' to be also OFTrue)

Returns
  EC_Normal upon success, an error code otherwise

## ◆ setOFTime()

OFCondition DcmTime::setOFTime | ( | const OFTime & | timeValue | ) |

set the element value to the given time

Parameters

  timeValue | time to be set (should be a valid time)

Returns
  EC_Normal upon success, an error code otherwise

The documentation for this class was generated from the following file:

- dcmdata/include/dcmtk/dcmdata/dcvrtm.h

Generated on Mon Dec 15 2025 for DCMTK Version 3.7.0 by Doxygen 1.9.1